/*
 File: identifier.h
 Date and Time: Fri Jan 30 18:55:12 2015 
*/
#ifndef __identifier_h__
#define __identifier_h__ 1
#include "yacco2.h"
#include "yacco2_T_enumeration.h"
#include "yacco2_k_symbols.h"
#include "yacco2_err_symbols.h"
#include "yacco2_terminals.h"
#include "yacco2_characters.h"

#include "yacco2_stbl.h"
  
extern yacco2::Thread_entry ITH_identifier;

extern yacco2::State S1_Cidentifier;
namespace NS_identifier {
yacco2::THR _YACCO2_CALL_TYPE
TH_identifier(yacco2::Parser* Caller);// called thread
yacco2::THR_result _YACCO2_CALL_TYPE
PROC_TH_identifier(yacco2::Parser* Caller);// called thread's twin the procedure
using namespace NS_yacco2_T_enum;// enumerate
using namespace yacco2;
struct fsm_rules_reuse_table_type{
 fsm_rules_reuse_table_type();
 int no_rules_entries_;
 Per_rule_s_reuse_table* per_rule_s_table_[8];
};
class Cidentifier: public yacco2::CAbs_fsm {
 public:
  enum rules_and_subrules{
   start_of_rule_list = NS_yacco2_T_enum::T_Enum::sum_total_T
   ,R_Ridentifier_ = 569//start_of_rule_list + 0
    ,rhs1_Ridentifier_ = 1
    ,rhs2_Ridentifier_ = 2
   ,R_Rid_suffix_ = 570//start_of_rule_list + 2
    ,rhs1_Rid_suffix_ = 3
   ,R_Rstart_char_ = 571//start_of_rule_list + 4
    ,rhs1_Rstart_char_ = 4
    ,rhs2_Rstart_char_ = 5
    ,rhs3_Rstart_char_ = 6
    ,rhs4_Rstart_char_ = 7
   ,R_RUPPER_A_M_ = 572//start_of_rule_list + 6
    ,rhs1_RUPPER_A_M_ = 8
    ,rhs2_RUPPER_A_M_ = 9
    ,rhs3_RUPPER_A_M_ = 10
    ,rhs4_RUPPER_A_M_ = 11
    ,rhs5_RUPPER_A_M_ = 12
    ,rhs6_RUPPER_A_M_ = 13
    ,rhs7_RUPPER_A_M_ = 14
    ,rhs8_RUPPER_A_M_ = 15
    ,rhs9_RUPPER_A_M_ = 16
    ,rhs10_RUPPER_A_M_ = 17
    ,rhs11_RUPPER_A_M_ = 18
    ,rhs12_RUPPER_A_M_ = 19
    ,rhs13_RUPPER_A_M_ = 20
   ,R_RUPPER_N_Z_ = 573//start_of_rule_list + 8
    ,rhs1_RUPPER_N_Z_ = 21
    ,rhs2_RUPPER_N_Z_ = 22
    ,rhs3_RUPPER_N_Z_ = 23
    ,rhs4_RUPPER_N_Z_ = 24
    ,rhs5_RUPPER_N_Z_ = 25
    ,rhs6_RUPPER_N_Z_ = 26
    ,rhs7_RUPPER_N_Z_ = 27
    ,rhs8_RUPPER_N_Z_ = 28
    ,rhs9_RUPPER_N_Z_ = 29
    ,rhs10_RUPPER_N_Z_ = 30
    ,rhs11_RUPPER_N_Z_ = 31
    ,rhs12_RUPPER_N_Z_ = 32
    ,rhs13_RUPPER_N_Z_ = 33
   ,R_Rlower_a_m_ = 574//start_of_rule_list + 10
    ,rhs1_Rlower_a_m_ = 34
    ,rhs2_Rlower_a_m_ = 35
    ,rhs3_Rlower_a_m_ = 36
    ,rhs4_Rlower_a_m_ = 37
    ,rhs5_Rlower_a_m_ = 38
    ,rhs6_Rlower_a_m_ = 39
    ,rhs7_Rlower_a_m_ = 40
    ,rhs8_Rlower_a_m_ = 41
    ,rhs9_Rlower_a_m_ = 42
    ,rhs10_Rlower_a_m_ = 43
    ,rhs11_Rlower_a_m_ = 44
    ,rhs12_Rlower_a_m_ = 45
    ,rhs13_Rlower_a_m_ = 46
   ,R_Rlower_n_z_ = 575//start_of_rule_list + 12
    ,rhs1_Rlower_n_z_ = 47
    ,rhs2_Rlower_n_z_ = 48
    ,rhs3_Rlower_n_z_ = 49
    ,rhs4_Rlower_n_z_ = 50
    ,rhs5_Rlower_n_z_ = 51
    ,rhs6_Rlower_n_z_ = 52
    ,rhs7_Rlower_n_z_ = 53
    ,rhs8_Rlower_n_z_ = 54
    ,rhs9_Rlower_n_z_ = 55
    ,rhs10_Rlower_n_z_ = 56
    ,rhs11_Rlower_n_z_ = 57
    ,rhs12_Rlower_n_z_ = 58
    ,rhs13_Rlower_n_z_ = 59
   ,R_RNUMBERS_ = 576//start_of_rule_list + 14
    ,rhs1_RNUMBERS_ = 60
    ,rhs2_RNUMBERS_ = 61
    ,rhs3_RNUMBERS_ = 62
    ,rhs4_RNUMBERS_ = 63
    ,rhs5_RNUMBERS_ = 64
    ,rhs6_RNUMBERS_ = 65
    ,rhs7_RNUMBERS_ = 66
    ,rhs8_RNUMBERS_ = 67
    ,rhs9_RNUMBERS_ = 68
    ,rhs10_RNUMBERS_ = 69
  };
  //no of la sets = 1
  //no of states = 60
  Cidentifier();
  ~Cidentifier();
  void op();
  bool failed();
  void reduce_rhs_of_rule
      (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule);
  fsm_rules_reuse_table_type fsm_rules_reuse_table;
  static int rhs_to_rules_mapping_[70];
  
    public:
    int hyphen_pos_;
    int hyphen_idx_;
    CAbs_lr1_sym* hyphen_;
    char ddd_[1024];
    int ddd_idx_;
  
 };
struct Ridentifier;
struct Rid_suffix;
struct Rstart_char;
struct RUPPER_A_M;
struct RUPPER_N_Z;
struct Rlower_a_m;
struct Rlower_n_z;
struct RNUMBERS;
struct Ridentifier:public yacco2::CAbs_lr1_sym {
  Ridentifier(yacco2::Parser* P);
  void op();
  public:
};

struct Rid_suffix:public yacco2::CAbs_lr1_sym {
  Rid_suffix(yacco2::Parser* P);
  public:
  void sr1();
};

struct Rstart_char:public yacco2::CAbs_lr1_sym {
  Rstart_char(yacco2::Parser* P);
  public:
};

struct RUPPER_A_M:public yacco2::CAbs_lr1_sym {
  RUPPER_A_M(yacco2::Parser* P);
  void op();
  public:
};

struct RUPPER_N_Z:public yacco2::CAbs_lr1_sym {
  RUPPER_N_Z(yacco2::Parser* P);
  void op();
  public:
};

struct Rlower_a_m:public yacco2::CAbs_lr1_sym {
  Rlower_a_m(yacco2::Parser* P);
  void op();
  public:
};

struct Rlower_n_z:public yacco2::CAbs_lr1_sym {
  Rlower_n_z(yacco2::Parser* P);
  void op();
  public:
};

struct RNUMBERS:public yacco2::CAbs_lr1_sym {
  RNUMBERS(yacco2::Parser* P);
  void op();
  public:
};

} // end of namespace

#endif
